#
# spec file for package iproute2
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           iproute2
BuildRequires:  bison db-devel flex ghostscript-fonts-std ghostscript-x11 libpng-devel libtiff-devel sgmltool texlive-latex xorg-x11-devel
BuildRequires:  iptables-devel
License:        GPLv2+
Group:          Productivity/Networking/Routing
Provides:       iproute
Version:        2.6.37
Release:        4.5.1
%define rversion        2.6.37
Summary:        Advanced Routing
Url:            http://developer.osdl.org/dev/iproute2/
Source0:        %name-%rversion.tar.bz2
Patch0:         %name-2.6.29-1-libdir-1.diff
Patch1:         %name-2.6.29-1-HZ.diff
Patch2:         %name-2.6.29-1-pdfdoc.diff
Patch5:         %name-2.6.29-1-flushcheckuid.diff
Patch7:         %name-2.6.29-1-warnings.diff
Patch8:         %name-2.6.29-1-skbedit-memset.diff
Patch9:         %name-2.6.29-1-iptunnel-fclose.diff
Patch10:        %name-2.6.29-1-ss-pclose.diff
Patch13:        %name-2.6.29-1-memleak.diff
Patch14:        %name-2.6.37-rtt-metrics-units.diff
Patch15:        %name-correct-error-code.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This package provides the tools ip, tc, and rtmon needed to use the new
and advanced routing options of the Linux kernel. The SUSE Linux
distribution has used this package for network setup since SuSE Linux
8.0.

Authors:
--------
    Alexey Kuznetsov <kuznet at ms2 dot inr dot ac dot ru>
    Stephem Hemminger <shemminger at osdl dot org>

%package -n libnetlink-devel
License:        GPLv2+
Summary:        A Higher Level Interface to the Netlink Service
Group:          Development/Libraries/C and C++
Provides:       libnetlink = %version-%release

%description -n libnetlink-devel
libnetlink provides a higher level interface to rtnetlink(7).

%package doc
License:        GPLv2+
Summary:        Documentation to iproute2
Group:          Documentation
%if 0%{?suse_version} >= 1130
BuildArch:      noarch
%endif

%description doc
This package contains the PDF documentation from iproute2,
as well as examples and other outdated files.

%prep
%setup -q -n %name-%rversion
%patch0
%patch1
%patch2
%patch5
%patch7
%patch8
%patch9
%patch10
%patch13
%patch14 -p1
%patch15 -p1
find . -name *.orig -print0 | xargs -r0 rm -v

%build
# build with -fPIC. For details see
# https://bugzilla.novell.com/show_bug.cgi?id=388021
make %{?_smp_mflags} LIBDIR=%_libdir CCOPTS="-D_GNU_SOURCE $RPM_OPT_FLAGS -Wstrict-prototypes -fPIC"
cd doc
make pdf

%install
install -d $RPM_BUILD_ROOT/{etc/,sbin/,usr/{sbin,share/man/man{3,8}}}
install -d $RPM_BUILD_ROOT/{/usr/include,%_libdir,/usr/share}
make install DESTDIR=$RPM_BUILD_ROOT LIBDIR=%_libdir \
	MODDESTDIR="$RPM_BUILD_ROOT/%_libdir"
rm -f "$RPM_BUILD_ROOT/%_libdir/m_ipt.so"
install lib/libnetlink.a $RPM_BUILD_ROOT/%_libdir
install include/libnetlink.h $RPM_BUILD_ROOT/usr/include
mv $RPM_BUILD_ROOT/usr/sbin/ip $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/bin
ln -sf /sbin/ip $RPM_BUILD_ROOT/bin/ip
rm $RPM_BUILD_ROOT/usr/sbin/ifcfg

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README* RELNOTES
/usr/sbin/*
/sbin/*
/bin/ip
%_mandir/man8/*
%dir /etc/iproute2
%config(noreplace) /etc/iproute2/rt_dsfield
%config(noreplace) /etc/iproute2/rt_protos
%config(noreplace) /etc/iproute2/rt_scopes
%config(noreplace) /etc/iproute2/rt_realms
%config(noreplace) /etc/iproute2/rt_tables
%config(noreplace) /etc/iproute2/ematch_map
%_libdir/m_xt.so
%dir /usr/share/tc
%attr(644,root,root)/usr/share/tc/*

%files doc
%defattr(-,root,root)
%doc doc/api-ip6-flowlabels.pdf doc/arpd.pdf doc/ip-cref.pdf
%doc doc/ip-tunnels.pdf doc/nstat.pdf doc/rtstat.pdf doc/ss.pdf
%doc ChangeLog examples/ ip/ifcfg ip/routef ip/routel

%files -n libnetlink-devel
%defattr(-,root,root)
/usr/include/*
%_mandir/man3/libnetlink*
%_libdir/lib*

%changelog
* Mon Jul 25 2011 bili@suse.com
- Add iproute2-correct-error-code.patch to fix return error code
  (bnc#681952, swampid#41543).
* Wed Jan 12 2011 mt@suse.de
- Adopted ip route rtt,rttvar,rto_min metrics time unit to
  milliseconds as required by recent kernels (bnc#659746).
* Tue Jan 11 2011 jengelh@medozas.de
- Update to iproute2-2.6.37
  * Support for iptables >= 1.4.9
  * Support for GRE in XFRM
  * tc f_flow now knows rxhash
  * Support for macvtap "mode" parameter
  * tc ACT_CSUM support
  * added `ip route save` and `ip route restore` commands
- Spec file updates
  * Remove pointless AutoReqProv:on (that's the default)
  * Enable tc's m_xt
* Fri Dec  3 2010 ms@suse.de
- removed the fragtimeout patch because it breaks the rto_min
  setup. The fragtimeout patch also requires a kernel side
  modification which we don't ship since SLES9 (bnc #656667)
* Mon Nov 15 2010 jengelh@medozas.de
- Split documentation into its own subpackage, reducing the size
  of the main package by ~500K
* Wed Nov  3 2010 jengelh@medozas.de
- Update to iproute2-2.6.35+git9 for obtaining
  Linux 2.6.36-introduced features (no iproute2-2.6.36 tag yet)
  * Added RTA_MARK support (e.g. `ip route get ::1 mark 2`)
  * 64-bit interface statistics
* Tue Nov  2 2010 jengelh@medozas.de
- Update to iproute2-2.6.35
  * Added support for multicast iprules
  * Speed up `ss -p`
  * Update ARP header type table
* Tue Nov  2 2010 jengelh@medozas.de
- Update to iproute2-2.6.34
  * Fix build issues with flex 2.5
  * Detect 6rd tunnel scope
  * Added `ip tuntap` support (this practically obsoletes the
  "tunctl" package)
  * Added support for XFRM/SA by fwmark
  * Added initrwnd
- 2 patches integrated, thus dropped
* Tue Nov  2 2010 jengelh@medozas.de
- Update to iproute2-2.6.33
  * Added 6rd support
  * Added macvlan options for bridge mode
  * Added support to mark packets in skbedit
  * Added oif classification support in iprule
* Tue Nov  2 2010 jengelh@medozas.de
- Update to iproute2-2.6.31
  * Dropped equalize support
  * Fixed segfault when using garbage lladdr
  * Added new m_xt module for iptables-1.4.5
  * Added support for CAN
  * Allow ISATAP with stateless autoconfiguration
  * Added support for cgroup
  * Added support for monitoring neigh table activities
- 3 patches integrated, thus dropped
* Tue Feb 23 2010 jengelh@medozas.de
- add a patch to avoid tun tunnels being shown as "link/65534"
* Sat Dec 19 2009 jengelh@medozas.de
- enable parallel build
* Wed Nov 11 2009 ms@suse.de
- check effective UID instead of real UID in the flush
  permissions coding (bnc #554419)
* Fri Oct  9 2009 ms@suse.de
- added missing fclose to ss utility (bnc #543986)
* Wed Sep 16 2009 ms@suse.de
- fixed memory leak in read_igmp() function ip/ipmaddr.c (bnc #538996)
* Thu Sep 10 2009 ms@suse.de
- added support for monitoring neighbour tables (bnc #537906)
- added support for displaying type labels (bnc #537906)
* Fri Aug 28 2009 ms@suse.de
- added missing pclose (bnc #534912)
* Wed Aug 26 2009 mls@suse.de
- make patch0 usage consistent
* Wed Aug 12 2009 adrian@suse.de
- update to version 2.6.29-1
  * Support for lxc
* Tue Jul 28 2009 ms@suse.de
- make sure do_tunnels_list proc file descriptor will be
  closed after use or on proc read error (bnc #525834)
* Thu Feb 19 2009 ms@suse.de
- fixed ss utility to display inet6 addresses if requested
  with -6 or -f inet6 (bnc #473156)
* Tue Jan 27 2009 ms@suse.de
- fixed a bug in which the memory for the tc_skbedit struct was
  being used uninitialized to 0.  This patch corrects the issue
  by using a memset to 0 out the memory of the
  structure (bnc #438950)
* Thu Dec 11 2008 agruen@suse.de
- Change max length of the MAC address from 16 bytes to 32 bytes
  to accommodate infiniband (bnc#445014).
* Mon Oct 13 2008 ms@suse.de
- fixed compiler warnings (bnc #434714)
* Thu Sep 18 2008 hare@suse.de
- Add skbedit support for FCoE (FATE#303914)
- Add multiqueue support for FCoE (FATE#303914)
- Rename libnl to libnetlink-devel
- Fix IPPROTO_DCCP redefine
- rpmlint fixes
* Mon Jul 14 2008 ms@suse.de
- update to version 2.6.25
  * Fix off by one in nested attribute management.
  * netem potential dist table overflow
  * rto_min value display overflow
  * Overhead calculation is now done in the kernel.
  * libnetlink: don't spin forever on receive error
  * Protocol field on tc_filter is required by the kernel, provide it
  * Add missing prefix bit length for addrlabel
  * Do not strip binaries with `install`
  * In police, fix uninitialized "overhead" variable.
  * lots of documentation fixes
* Fri Jul 11 2008 ms@suse.de
- fixed RTM_NEWLINK check for older kernels (bnc #407954)
* Mon Jun 30 2008 ms@suse.de
- fixed 'tc qdisc' segmentation fault (bnc #404755)
* Thu May  8 2008 ms@suse.de
- compile libnetlink with -fPIC (bnc #388021)
* Wed Apr 16 2008 schwab@suse.de
- Don't strip binaries.
* Thu Oct 25 2007 ms@suse.de
- update to version 2.6.23, fixed (#336488)
  Reason for update:
  * The macvlan module, which got added to the kernel in version
    2.6.23, needs the new "ip link add" feature
  These patches add a rewritten version of Ben's macvlan driver, which
  allows to create virtual ethernet devices. The underlying device is
  put in promiscous mode and packets are demuxed based on MAC address.
  It behaves similar to bridge devices in that packets are visible on
  the real device before delivery to the macvlan driver. The driver
  supports all features of the underlying device except VLAN
  acceleration, this is currently very hard to support. I might look
  into this in the future.
  The main downside of this driver is that it adds another hook in
  netif_receive_skb, unfortunately that is unavoidable. When not
  compiled in the hook vanishes of course.
  Usage is simple:
    ip link add link eth0 type macvlan
  Will create a macvlan0 device with a random MAC address on top of
  eth0. No iproute patches are required.
* Tue Oct 16 2007 jdelvare@suse.de
- libnetlink.3 is now part of the upstream package, no need to
  include our own copy.
* Wed Jul 11 2007 ms@suse.de
- update to version 2.6.22, fixed (#288551)
  * Kim Woelders <kim@woelders.dk>, various useful fixups: compilation
  with old kernels, cross-compiling, "all" == "any" in prefix spec.
  * Collected from my disk, cleaned and packed to directory iproute2/misc/
    several utilities: ss, nstat, ifstat, rtacct, arpd and module tcp_diag.
    Writing some docs. me.
  * prepared patchlet for pidentd to use tcp_diag.
  * David Miller: 64bit (and even worse 64bit kernel/32 bit user :-) fixes
    to above. tcp_diag is merged to main tree.
  * Alexandr D. Kanevskiy <kad@blackcatlinux.com>: various flaws in ss
  * Alexandr D. Kanevskiy <kad@blackcatlinux.com>: oops, more aggressive caching
    of names opened old bugs: ip started to print garbage in some places.
  * Robert Olsson, rt_cache_stat. Renamed to rtstat.
  * An old bug in "ip maddr ls": reduntant empty lines in output.
    Seeing this crap for ages but lucky match of desire/ability to repair
    and a huff about this happened only today. :-)
  * "Mr. James W. Laferriere" <babydr@baby-dragons.com>
    doc: option to produce ps output for non-a4 and not only 2 pages/sheet.
  * Jamal's patch for ingres qdisc.
  * Bernd Eckenfels <ecki@lina.inka.de>: deleted orphaned bogus #include
    in include/utils.h.
  * Julian Anastasov <ja@ssi.bg>: uninitialized fields in nexthop
    producing funny "dead" nexthops in multipath routes.
    Stupid me, look at the first line in [010803]... Was it difficult to guess
    this that time? People blame for several months. :-)
    Special thanks to bert hubert <ahu@ds9a.nl> who raised the issue in netdev.
    Thanks and apologies to Terry Schmidt <terry@nycwireless.net>,
    Ruben Puettmann <ruben.puettmann@freenet-ag.de>,
    Mark Ivens <mivens@clara.net>.
  * willy tarreau <wtarreau@yahoo.fr>: "make install" target.
  * Tunable limit for sch_sfq. Patch to kernel activating this
    is about to be submitted. Reminded by Adi Nugroho <Adi@iNterNUX.co.id>
* Fri Apr 20 2007 aj@suse.de
- Use texlive for building.
* Mon Apr  2 2007 rguenther@suse.de
- add bison and flex BuildRequires
* Thu Feb  8 2007 ms@suse.de
- fixed array size of name string in iptables.h (#243281)
  array of size IPT_FUNCTION_MAXNAMELEN - 1 is referenced
  at element IPT_FUNCTION_MAXNAMELEN - 1 which is outside the
  array bounds
* Mon Jan 29 2007 ms@suse.de
- fixed wrong IPT_LIB_DIR value and replaced the code by a
  dynamic check for the /usr/%%lib/iptables directory (#238886)
* Tue Nov  7 2006 ro@suse.de
- fix permissions for manpage
* Thu Jul 20 2006 ms@suse.de
- replaced static HZ define to dynamic:
  [#]ifndef HZ
  [#]define HZ sysconf(_SC_CLK_TCK)
  [#]endif
* Thu May 25 2006 schwab@suse.de
- Fix crash while resolving addresses.
* Mon Apr  3 2006 hvogel@suse.de
- fix flex input file to use uppercase STR to avoid conflicts.
  This prevented tc from being build [#162931]
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jan 17 2006 mrueckert@suse.de
- update to version 2.6.15-060110
* Tue Nov  8 2005 mmj@suse.de
- update to version 051107
* Sun Oct 23 2005 ro@suse.de
- fix filelist for libnlink
* Thu Oct 20 2005 mmj@suse.de
- update to version 051007
- fix buffer overflow in iproute.c [#129415] (thanks Richard, Marcus)
- don't strip stuff
* Wed Aug 17 2005 cthiel@suse.de
- update to version 050816 [#105087]
* Sat Aug  6 2005 dmueller@suse.de
- add /bin/ip symlink (#102513)
* Wed Jun 15 2005 meissner@suse.de
- use RPM_OPT_FLAGS
* Mon May  9 2005 mmj@suse.de
- Update to 2.6.11-050330
* Thu Feb 10 2005 ro@suse.de
- remove dropped tetex subpackages from nfb
* Fri Feb  4 2005 mmj@suse.de
- Update to 2.6.10-ss050124
* Tue Dec  7 2004 mmj@suse.de
- Don't trust that the kernel and do our own family check [#48600]
* Sun Oct 24 2004 mmj@suse.de
- Clean up spec file a bit
- Update to new snapshot including even more of our patches
* Tue Oct 12 2004 mmj@suse.de
- Update to 2.6.9 including some of our patches
* Tue Aug 17 2004 mmj@suse.de
- Make ip print correct type when printing stats [#42589]
* Wed Apr 21 2004 mmj@suse.de
- Fix bufferoverflow in nstat [#39179]
* Fri Apr 16 2004 kukuk@suse.de
- Fix compiling with 2.6.5 kernel headers
- Remove backup files
* Wed Apr 14 2004 mmj@suse.de
- Don't remove buildroot before install
* Wed Mar 17 2004 mmj@suse.de
- No executables below /usr/include [#36342]
* Wed Mar 10 2004 mmj@suse.de
- Olaf Kirch fixed the kernel, so remove the fix for [#35288]
* Wed Mar  3 2004 ak@suse.de
- Fix hang in ip addr flush (#35288)
* Wed Jan  7 2004 mmj@suse.de
- ifstat should store it's history in /var/tmp not /tmp
* Mon Nov 10 2003 mmj@suse.de
- Add more man-pages [#32981]
* Wed Oct 15 2003 mmj@suse.de
- Don't build as root
* Mon Aug 11 2003 mmj@suse.de
- Add all the pdf documentation [#28637]
* Thu Jun 12 2003 kukuk@suse.de
- Fix filelist
* Wed Jun  4 2003 kukuk@suse.de
- Don't use include-glibc directory
- Fix arpd to compile with db4
* Tue May 13 2003 mmj@suse.de
- Remove files we don't package
* Mon May 12 2003 mmj@suse.de
- Add glib-include from newer iputils, and change a kernel-include
  to make it build
* Tue Feb 11 2003 ug@suse.de
- patch for HTB support applied since 2.4.20 supports it
* Fri Feb  7 2003 mmj@suse.de
- Make the man tar-ball not contain gzipped man-pages, it's already
  compressed once.
- Apply patch from Andi Kleen for fragtimeout functionality
* Mon Nov 11 2002 ro@suse.de
- changed neededforbuild <xshared> to <x-devel-packages>
* Mon Nov 11 2002 ro@suse.de
- changed neededforbuild <sp> to <opensp>
* Sun Oct 20 2002 mmj@suse.de
- Add manpages, thanks to ASPLinux [#21115]
* Wed Aug 21 2002 mmj@suse.de
- Added a patch to exit when regular user tries to flush routes or
  addresses. [#16000]
* Sun Aug 18 2002 ro@suse.de
- added ghostscript-x11-packages to neededforbuild (for gs)
* Mon Apr  8 2002 postadal@suse.cz
- updated to ss020116
  * added several utilities several utilities: ss, nstat, ifstat,
    rtacct, arpd and module tcp_diag
* Thu Jan 31 2002 ro@suse.de
- changed neededforbuild <libpng> to <libpng-devel-packages>
* Thu Jan 31 2002 ro@suse.de
- added libgimpprint to neededforbuild
* Tue Jan 29 2002 vinil@suse.cz
- /usr/lib -> %%_libdir
* Sun Jan 20 2002 vinil@suse.cz
- new version ss010824
- spec file cleanup
* Mon Nov 19 2001 bjacke@suse.de
- move ip to /sbin
- add iproute2 config files to /etc/
* Wed Oct 10 2001 stepan@suse.de
- fix compilation on ia64
* Tue Sep 18 2001 pthomas@suse.de
- Correct spelling in libnetlink.3
- Add both German and English descriptions for libnlink
* Mon Aug 27 2001 kukuk@suse.de
- Fix compiling on SPARC
* Tue Aug 21 2001 vinil@suse.cz
- new version ss010803
- get rid of kernel 2.2 patches
* Thu Jul 26 2001 kukuk@suse.de
- add glib to needed for build
* Fri Jul 20 2001 kukuk@suse.de
- changed neededforbuild <gs_fonts> to <ghostscript-fonts-std>
- changed neededforbuild <gs_lib> to <ghostscript-library>
- changed neededforbuild <gs_x11> to <ghostscript-x11>
* Tue Jun 26 2001 ro@suse.de
- ETH_P_ECHO is apparently no longer defined
* Thu Mar  8 2001 uli@suse.de
- added xshared to neededforbuild
* Mon Mar  5 2001 kukuk@suse.de
- Remove bogus check for kernel header
* Fri Dec  1 2000 kukuk@suse.de
- Update to iproute2-2.2.4-now-ss001007 to fix compile problems
  with new kernel and glibc
* Mon Aug 28 2000 ak@suse.de
- fix permissions
- fix advmss/mtu confusion between 2.2 and 2.4 (advmss now works with 2.2
  kernels and is always enabled)
- add a new subrpm for libnetlink
- add libnetlink man page
* Tue Jul  4 2000 mha@suse.de
- new version (2.2.4-now-ss000305)
- new README.SuSE
- use ps2pdf instead of pdflatex, because the latter produces
  unusable pdf files for some reason
* Thu Jun  1 2000 vinil@suse.cz
- documentation enhancement
* Fri May 26 2000 vinil@suse.cz
- new version (ss000225)
- buildroot added
- sorted in group
* Thu Feb 17 2000 mha@suse.de
- new version (ss991023)
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Thu Jul 22 1999 mha@suse.de
- new version
- renamed package iproute->iproute2, because that's how the author
  calls it
* Tue Jul 13 1999 ro@suse.de
- added psutils to neededforbuild
* Sun Jul 11 1999 mha@suse.de
- new package: iproute (tools for using the advanced routing options
    in kernel 2.2)
